;;;    SNAP_ROT.LSP 9/19/00

(defun red (a / )
	(cond 
		((> a 0.0)(while (> a (* pi 0.5))(setq a (- a (* pi 0.5)))))
		((< a 0.0)(while (< a 0.0)(setq a (+ a (* pi 0.5)))))
	)
	a
)

(defun sna_rot_p ( / en el et p1 p2 ang)
	(while(not (setq en (nentsel))))
	(setq 	el (entget (car en))
		et (cdr (assoc 0 el))
 	)
	(cond 
		((or (= et "POLYLINE") (= et "LWPOLYLINE") (= et "LINE"))
			(progn
				(setq 	p1 (osnap (cadr en) "nea")
          				p2 (osnap (cadr en) "end")
					ang (angle p1 p2)
     				)
				(setvar "snapang" (red ang))
				(setvar "orthomode" 1)
			)
		)
		(t
			(progn
				(alert "\n  Entity selected is not a LINE. Try again.")
				(sna_rot_p)
			)
		)
	)
	(princ)
)

(defun sna_rot_a (/ ang) 
	(if(not(new_dialog "snaptype" dcl_id))(exit))
	(set_tile "a" (angtos (getvar "snapang") 0 2))
	(mode_tile "a" 2)
	(action_tile "a" "(progn(setq ang (red(* pi (/ (atof $value) 180.0))))(done_dialog)(unload_dialog dcl_id))")
	(action_tile "accept" "(progn(setq ang (red(* pi (/ (atof (get_tile \"a\")) 180.0))))(done_dialog)(unload_dialog dcl_id))")
	(action_tile "cancel" "(progn(done_dialog)(unload_dialog dcl_id))")
	(start_dialog)
	(if (not(bitsetp (getvar "autosnap") 3))
		(progn
			(setvar "SNAPANG" ang)
			(setvar "ORTHOMODE" 1)
		)
		(progn
		
		)
	)
	(princ)
)

(defun sna_rot_r (/ risdis p1 p2 p3 ang)
	(setq risdis (* (/ (sin (getvar "snapang"))(cos (getvar "snapang"))) 12))
	(if(not(new_dialog "snaprise" dcl_id))(exit))
	(if (>= risdis 0)
		(set_tile "i" "0")
		(set_tile "i" "1")
	)
	(set_tile "r" (rtos(abs risdis) 2 0))
	(action_tile "r" 
		"(progn(setq risdis (*(if (equal (get_tile \"i\") \"1\")(setq i -1)(setq i 1))(atof $value)))(done_dialog)(unload_dialog dcl_id))")
	(action_tile "accept" 
		"(progn(setq risdis (*(if (equal (get_tile \"i\") \"1\")(setq i -1)(setq i 1))(atof (get_tile \"r\"))))(done_dialog)(unload_dialog dcl_id))")
	(action_tile "cancel" "(progn(done_dialog)(unload_dialog dcl_id))")
	(start_dialog)
	(setq 	p1 (getvar "LASTPOINT")
       		p2 (polar p1 0 12)
      		p3 (polar p2 (* 0.5 pi) risdis)
      		ang (red(angle p1 p3))
	)
	(setvar "SNAPANG" ang)
	(setvar "ORTHOMODE" 1)
	(princ)
)

(defun c:snaprot (/ dcl_id flg)
	
	(setq dcl_id (load_dialog "acadgenrl"))
	(if(not(new_dialog "snaprot" dcl_id))(exit))
	(action_tile "s" "(progn(done_dialog)(unload_dialog dcl_id)(setq flg t))")
	(action_tile "t" "(progn(sna_rot_a)(done_dialog))")
	(action_tile "r" "(progn(sna_rot_r)(done_dialog))")
	(action_tile "accept" "(progn(done_dialog)(unload_dialog dcl_id)(setq flg t))")
	(action_tile "cancel" "(progn(done_dialog)(unload_dialog dcl_id))")
	(start_dialog)
	(if flg(sna_rot_p))
	(princ)
)
(princ)
